﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public setup_power_layout As Boolean=False
	Public Action_Command As Boolean=False
	Public actif_save As Boolean=False
	Public Update_data_sensor_enable As Boolean=False
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim cs As CSBuilder
	Private Button_search_power As B4XView
	Private Label_name_sensor As B4XView
	
	Private Rdb_Bluetooth As B4XView
	Private Rdb_wifi As B4XView
	Private Lbl_type_connexion As B4XView
	Private Lbl_graph_battery As B4XView
	Dim Graph_MinValue As Int=0
	Dim Graph_MaxValue As Int=0
	Dim Graph_width As Int=0
	Private C_temp As String=""
	
	Private Niv_bat As B4XView
	Private Panel_sensor As B4XView
	Private Btn_modif_sensor As B4XView
	Private Btn_save_sensor As B4XView
	Private Lbl_Temp As B4XView
	Private Lbl_alerte_bat As B4XView
	Private Txt_Local_sensor As B4XView
	Private SeekBar_Temp_cons As B4XView
	Private file_Setup = ""
	Dim confirme_retour As Int
	Private Remove_Sensor As Boolean=False
	Private Xui As XUI
	
	Private Btn_trash As B4XView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	Activity.LoadLayout("Setup_sensor")
	
	file_Setup=Main.Localisation_Home & "_" & "setup.txt"
	
	' Calibration de l'indicateur de niveau de batterie
	'dim batterie
	Graph_MinValue = Lbl_graph_battery.Left
	Graph_MaxValue= Lbl_graph_battery.Left + Lbl_graph_battery.Width - Niv_bat.Width
	Dim ratio As Int= (Graph_MaxValue-Graph_MinValue)/50
	
	' Recherche dans le setup le sensor et vérifie si des éléments on changés. Si c'est le cas, indique "Mise à jour en cours"
	Dim find_sensor As Boolean=False
	
	For Each data As String In Main.list_Read_Setup
		Dim data_setup() As String =Regex.Split(";", data)
		
		
			If data_setup(2)=Cockpit.Macaddress Then
				If data_setup.Length=4 Then
					find_sensor=True
					
					'Définition level Battery de 50% = mini et 100%=Max
					'Cockpit.level_battery=50
					If Cockpit.level_battery<=50 Then
						Lbl_alerte_bat.Visible=True
						Lbl_alerte_bat.Text=Cockpit.level_battery & "%"
						Niv_bat.left=Graph_MinValue
					Else if Cockpit.level_battery>50 Then
						Lbl_alerte_bat.Visible=False
						Niv_bat.left=(Cockpit.level_battery-50)*ratio + Graph_MinValue
					End If
		
					If Cockpit.Local_sensor<>data_setup(1) Or Cockpit.T_consigne<> data_setup(3) Then
						Xui.MsgboxAsync("Une mise à jour est en cours","Information Sensor")
					End If
					Txt_Local_sensor.Text= data_setup(1)
					SeekBar_Temp_cons.Progress= data_setup(3)
					SeekBar_Temp_cons.Enabled=False
					Txt_Local_sensor.Enabled=False
				Else
					Activity.Finish
				End If
			End If
		
		
	Next

	If find_sensor=False Then 'Si le Sensor n'existe plus , on sort de la configuration
		Xui.MsgboxAsync("Le sensor a été supprimé. Mise à jour en cours","Information Sensor")
		Activity.Finish
	End If
	
	
	
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'return true if you want to consume the event
    
	
	
	Select KeyCode
		Case KeyCodes.KEYCODE_VOLUME_UP
			Log("Up")
			Return True
					
		Case KeyCodes.KEYCODE_VOLUME_DOWN
			Log("Down")
			Return True
		Case KeyCodes.KEYCODE_BACK
'			confirme_retour=confirme_retour+1
'			If confirme_retour=2 Then
'				
			'Return True
'				confirme_retour=0
'				
'			Else
'				ToastMessageShow("Appuyer sur la touche retour une seconde fois pour quitter.",True)
'			End If
			
			If actif_save=False And Action_Command=False Then
				Return False
			Else
				
				ToastMessageShow("Veuillez patienter...",True)
				Return True
			End If
		
		'Return True
	End Select
End Sub

Sub Activity_Resume
	setup_power_layout=True
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	
	setup_power_layout=False
End Sub

Sub Button_search_power_Click
	
End Sub

Sub Rdb_wifi_CheckedChange(Checked As Boolean)
	Lbl_type_connexion.Text=cs.Initialize.Typeface(Typeface.MATERIALICONS).Color(0xFF01FF20).Size(40).Append(Chr(0xE63E)).PopAll
End Sub

Sub Rdb_Bluetooth_CheckedChange(Checked As Boolean)
	Lbl_type_connexion.Text=cs.Initialize.Typeface(Typeface.MATERIALICONS).Color(0xFF01FF20).Size(40).Append(Chr(0xE1AA)).PopAll
End Sub

Sub SeekBar_Temp_cons_ValueChanged (Value As Int, UserChanged As Boolean)
	
	If Value<10 Then
		Lbl_Temp.Text="10°C"
		Lbl_Temp.RequestFocus
		C_temp=10
	Else
		Lbl_Temp.Text=Value & "°C"
		C_temp=Value
	End If
	
End Sub

Sub Btn_save_sensor_Click
	SeekBar_Temp_cons.Enabled=False
	Txt_Local_sensor.Enabled=False
	Btn_modif_sensor.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFF000000).Size(25).Append(Chr(0xF023)).PopAll
	actif_save=True
	Dim index_remove As Int
	
	For Each data As String In Main.list_Read_Setup 'Met à jour les données setup en mémoire
		Dim data_setup() As String =Regex.Split(";", data)
		If data_setup(2)=Cockpit.Macaddress Then
			
			If Remove_Sensor=True Then 'Supprime le sensor du Setup
				index_remove= Main.list_Read_Setup.IndexOf(data)
				Exit
			Else
				SeekBar_Temp_cons.Enabled=False 'ENregistre les nouveaux paramètres
				Dim new_data As String= data_setup(0) & ";" & Txt_Local_sensor.text & ";" & data_setup(2) & ";" & C_temp
				Log(Main.list_Read_Setup.IndexOf(data))
				Main.list_Read_Setup.Set(Main.list_Read_Setup.IndexOf(data),new_data)
			End If
			
		End If
	Next
	
	If Remove_Sensor=True Then 'Supprime le sensor du Setup
		Main.list_Read_setup.RemoveAt(index_remove)
		Btn_trash.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Size(25).Append(Chr(0xF1F8)).PopAll
		Btn_save_sensor.Enabled=False
		Btn_trash.Visible=False
	End If
	
		
	wait for (Param.write_file_setup(Main.list_Read_Setup, file_Setup,False,False)) complete (result As Boolean)
	
	If IsPaused(Transfert_Server)=True Then
		'Lbl_info_transfert.Visible=True
		Main.type_transfert=Cockpit.Upload_File_HH
		StartService(Transfert_Server)
	End If
	
	
End Sub

Sub result_transfert_upload(success As Boolean)
	
	If success=False Then
		Btn_save_sensor.TextColor=Colors.Red
	Else
		Btn_save_sensor.TextColor=Colors.Yellow
		'File.Delete(File.DirDefaultExternal, file_Setup) 'supprime le fichier local
		Btn_save_sensor.Enabled=False
		
		
		' lance une commande de lecture avec les nouveaux paramètres 
		
		file_Setup= Main.Localisation_Home & "_" & "command.txt"
		Action_Command=True
		actif_save=False
		wait for (Param.write_file_setup(Main.list_Read_Setup, file_Setup,False,False)) complete (result As Boolean)
		Sleep(2000)
		
		If IsPaused(Transfert_Server)=True Then
			'Lbl_info_transfert.Visible=True
			Main.type_transfert=Cockpit.Upload_File_HH
			StartService(Transfert_Server)
		End If
	End If
	
	file_Setup=Main.Localisation_Home & "_" & "setup.txt"
	Btn_save_sensor.TextColor=Colors.Green
	Update_data_sensor_enable=True 'Provoque la vérif sur le serveur toutes les 10s
	Cockpit.Timer1.Enabled=True
	
	If Cockpit.Timer2.Enabled=False Then 'Active l'icone de contrôle de nouvelles données sur le serveur
		Cockpit.Timer2.Enabled=True
	End If
	
End Sub

Sub Btn_modif_sensor_Click
	SeekBar_Temp_cons.Enabled=True
	Txt_Local_sensor.Enabled=True
	Btn_modif_sensor.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFF000000).Size(25).Append(Chr(0xF09C)).PopAll
	Btn_trash.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Size(25).Append(Chr(0xF1F8)).PopAll
	Btn_save_sensor.Enabled=True
	Btn_trash.Visible=True
End Sub

Sub Btn_trash_Click
	
	Dim sf As Object = Xui.Msgbox2Async("Etes-vous sûr de vouloir supprimer cette sonde ?","Suppression Sonde","Oui","Non","",Null)
	
	Wait For (sf) Msgbox_Result (Result As Int)
	If Result = Xui.DialogResponse_Positive Then
		Btn_trash.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFFFF0000).Size(25).Append(Chr(0xF1F8)).PopAll
		Remove_Sensor=True
		Btn_save_sensor_Click
	End If
	
	
	
End Sub