﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	'#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Private phone1 As Phone
	Dim notif_mess As NB6
	Dim notif_sensor As Notification
	
	Dim list_data_temp As List
	
	
	Dim S_FTP_Transfert As SFtp
		
	Dim FTP_adress As String="ssh.cluster028.hosting.ovh.net"
	Dim login As String="homeyhomld-FHEBERT"
	Dim pwd_ftp As String="bdHg47oyTz93Ajq80pPm"
	
	Dim filetotransfert As String=""
	Dim file_Data As String = ""
	Dim file_Setup As String= ""
	Dim file_Command As String= ""
	Dim PathServer As String=""
	Dim file_conf As String= "setup.txt"
		
	Dim JobStatus As Int
	Dim STATUS_NONE, STATUS_Upload_WORKING,STATUS_Download_WORKING, STATUS_DONE,STATUS_Destroy,STATUT_ERROR As Int
	
	STATUS_NONE = 0
	STATUS_Upload_WORKING = 1
	STATUS_Download_WORKING = 2
	STATUS_DONE = 3
	STATUS_Destroy =4
	STATUT_ERROR = 5
	
	Dim Download_File_HH, Upload_File_HH, Download_Setup_HH,Download_Conf_HH As Int
	
	Download_File_HH=1
	Upload_File_HH=2
	Download_Setup_HH=3
	Download_Conf_HH=4
	
End Sub

Sub Service_Create
	
	If phone1.SdkVersion>=26 Then
		Service.AutomaticForegroundMode =  Service.AUTOMATIC_FOREGROUND_ALWAYS
	End If
	
	file_Setup = Main.Localisation_Home & "_" & "setup.txt" 'Fichier de configutation sur le serveur
	file_Data = Main.Localisation_Home & "_" & "Data_Live_Sensor.txt"  'Fichier infos sensors sur le serveur
	file_Command = Main.Localisation_Home & "_" & "command.txt"
	list_data_temp.Initialize
	
	
		
	
	' intialisation des notifications
'	Dim show_icon As Bitmap
'	show_icon= LoadBitmapResize(File.DirAssets, "logoHH1.png", 32dip, 32dip, False)
'	notif_mess.Initialize("custom sound1", Application.LabelName, "DEFAULT").AutoCancel(True).BadgeIconType("LARGE")
'	notif_mess.SmallIcon(show_icon)
'	notif_mess.SetDefaults(True, True, False)
	'notif_mess.CustomSound(CreateFileProviderUri(folder, "intuition.mp3"))
	
	
	
	If phone1.SdkVersion>=26 Then
		Service.AutomaticForegroundMode =  Service.AUTOMATIC_FOREGROUND_ALWAYS
	End If
	
	'Initialisation SFTP
	
	S_FTP_Transfert.Initialize("S_FTP", login, pwd_ftp, FTP_adress,22)
	S_FTP_Transfert.SetKnownHostsStore(File.DirInternal, "hosts.txt")
		
	
	
	
	
End Sub

Sub S_FTP_PromptYesNo (message1 As String)
	
	#if debug
	Log("Auto accept Host Key")
	#End If
	S_FTP_Transfert.SetPromptResult(True)
End Sub

Sub CreateFileProviderUri (Dir As String, FileName As String) As Object
	Dim FileProvider As JavaObject
	Dim context As JavaObject
	context.InitializeContext
	FileProvider.InitializeStatic("android.support.v4.content.FileProvider")
	Dim f As JavaObject
	f.InitializeNewInstance("java.io.File", Array(Dir, FileName))
	Return FileProvider.RunMethod("getUriForFile", Array(context, Application.PackageName & ".provider", f))
End Sub

Sub Service_Start (StartingIntent As Intent)
	
				
		'Chargement de la liste des sensors
		
	S_FTP_Transfert.List("/home/" & login &"/Data_Sensor/")
	

End Sub


Sub S_FTP_ListCompleted (ServerPath As String, Success As Boolean, Folders() As SFtpEntry, Files() As SFtpEntry)
	
	
	
	If Success=True Then
		PathServer=ServerPath
		
		Dim time_zone As Long = DateTime.TimeZoneOffset*3600000 'Prise en compte du changement d'heure
		Dim date_file As Long
		DateTime.DateFormat="dd MMM yyyy HH:mm"
'		If JobStatus= STATUS_Upload_WORKING Then
'			If File.Exists(File.DirDefaultExternal,file_Data)=True Then
'				S_FTP_Transfert.UploadFile(File.DirDefaultExternal,file_Data,ServerPath & "Data_Sensor/" & file_Data)
'			End If
'		Else if JobStatus= STATUS_Download_WORKING Then
'			
'			If File.Exists(File.DirDefaultExternal,file_Setup)=True Then
'				S_FTP_Transfert.DownloadFile(ServerPath & "Data_Sensor/" & file_Setup,File.DirDefaultExternal,file_Setup)
'			End If
'			
'		End If

		If Main.type_transfert=Download_File_HH Then
			filetotransfert=file_Data
			
			For i= 0 To Files.length-1
				If Files(i).Name=filetotransfert Then
					date_file=Files(i).Timestamp '+ time_zone
					
				Dim DateOfFile As Long
				
				If File.Exists(File.DirDefaultExternal,filetotransfert)=True Then
					 DateOfFile = File.LastModified(File.DirDefaultExternal,filetotransfert)
				End If
					
					
					'Log(DateTime.date(DateOfFile))
					'Log(DateTime.Date(date_file))
					
					If DateOfFile < date_file Then 'Si le fichier sur le serveur est plus récent, on alerte de la mise jour
						Setup_Power_connected.Update_data_sensor_enable=False
						Log("Download")
						Download_file ' Récupération des infos sensors dans le Cloud
					Else if Setup_Power_connected.Update_data_sensor_enable=False Then 'Charge les données locales
						CallSub2(Cockpit,"load_sensor",False)
						S_FTP_Transfert.Close
						End_service
					Else
						S_FTP_Transfert.Close
						End_service
					End If
					Exit
				End If
			Next
					
			
		Else if Main.type_transfert=Upload_File_HH Then
			If Setup_Power_connected.Action_Command=True Then
				filetotransfert=file_Command
			Else
				filetotransfert=file_Setup
			End If
			
			Upload_file
		Else if Main.type_transfert=Download_Setup_HH Then
			filetotransfert=file_Setup
			Download_file ' Récupération du setup dans le Cloud
		Else if Main.type_transfert=Download_Conf_HH Then
			filetotransfert=file_conf
			Download_file ' Récupération du setup dans le Cloud
			
		End If
		
	Else
		JobStatus=STATUT_ERROR
		Log("Impossible d'accéder au serveur")
		S_FTP_Transfert.Close
		CallSub(Main,"alerte")
		End_service
	End If
	
	
End Sub


Sub Upload_file
	JobStatus= STATUS_Upload_WORKING
	' function send files on Cloud to be defined
	
	'S_FTP_Transfert.List("/home/" & login &"/")
	
	If File.Exists(File.DirDefaultExternal,filetotransfert)=True Then
		S_FTP_Transfert.UploadFile(File.DirDefaultExternal,filetotransfert,PathServer & filetotransfert)
	End If

End Sub

Sub Download_file
	JobStatus= STATUS_Download_WORKING
	' function send files on Cloud to be defined
			

	S_FTP_Transfert.DownloadFile(PathServer & filetotransfert,File.DirDefaultExternal,filetotransfert)

End Sub



Sub S_FTP_DownloadCompleted (ServerPath As String, Success_upload As Boolean)
	JobStatus = STATUS_DONE
	
	If Success_upload=True Then
		
		CallSub2(Cockpit,"alerte",Success_upload)
		Wait For (Param.read_file_setup(filetotransfert)) complete (result As Boolean)
		
		If Main.type_transfert=Download_File_HH Then 
			CallSub2(Cockpit,"load_sensor",result)
			S_FTP_Transfert.Close
			End_service
		Else If Main.type_transfert=Download_Setup_HH Then 'on télécharge les datas sensors après le setup
			CallSub2(Cockpit,"load_setup",result)
			Main.type_transfert=Download_File_HH
			S_FTP_Transfert.List("/home/" & login &"/Data_Sensor/")
		Else If Main.type_transfert=Download_Conf_HH Then 'on télécharge le fichier de conf
			CallSub2(Main,"load_conf",result)
			S_FTP_Transfert.Close
			End_service
		End If
	Else
		CallSub2(Cockpit,"alerte",Success_upload)
		End_service
	End If
	
	
End Sub


Sub S_FTP_UploadCompleted (ServerPath As String, Success_upload As Boolean)
	JobStatus = STATUS_DONE
	If Success_upload=True Then
		Log("Upload Ok")
	End If
	
	If Setup_Power_connected.setup_power_layout=True Then
		
		If Setup_Power_connected.Action_Command=False Then 'Renvoie un acquittement uniquement pour l'upload du setup
			CallSub2(Setup_Power_connected,"result_transfert_upload",Success_upload)
		Else
			Setup_Power_connected.Action_Command=False
		End If
		
	Else
		CallSub2(Setup,"result_transfert_upload",Success_upload)
	End If
	
	S_FTP_Transfert.Close
	End_service
End Sub



'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub End_service
			
	If phone1.SdkVersion>=26 Then
		Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
		
	End If
	
	StopService(Me)
End Sub


Sub Service_Destroy 
	JobStatus = STATUS_Destroy
End Sub
